'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _reactTestRenderer = require('react-test-renderer');

var _reactTestRenderer2 = _interopRequireDefault(_reactTestRenderer);

var _reactRedux = require('react-redux');

var _createRenderer = require('./createRenderer');

var _createRenderer2 = _interopRequireDefault(_createRenderer);

var _snap = require('./snap');

var _snap2 = _interopRequireDefault(_snap);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

exports.default = function (store, ReactComponentClass, mapStateToProps) {
  var wrapper = void 0;

  store.subscribe(function () {
    wrapper.forceUpdate();
  });

  var element = _react2.default.createElement(
    _reactRedux.Provider,
    { store: store },
    _react2.default.createElement(ReactiveWrapper, {
      ref: function ref(wr) {
        return wrapper = wr;
      },
      store: store,
      Component: ReactComponentClass,
      mapStateToProps: mapStateToProps
    })
  );

  var instance = _reactTestRenderer2.default.create(element);
  var app = (0, _createRenderer2.default)(instance);

  addMethods(app, store, element);

  return app;
};

var ReactiveWrapper = function (_React$Component) {
  _inherits(ReactiveWrapper, _React$Component);

  function ReactiveWrapper() {
    _classCallCheck(this, ReactiveWrapper);

    return _possibleConstructorReturn(this, (ReactiveWrapper.__proto__ || Object.getPrototypeOf(ReactiveWrapper)).apply(this, arguments));
  }

  _createClass(ReactiveWrapper, [{
    key: 'render',
    value: function render() {
      var _props = this.props,
          store = _props.store,
          Component = _props.Component,
          mapStateToProps = _props.mapStateToProps;


      var props = typeof mapStateToProps === 'function' ? mapStateToProps(store.getState(), store.dispatch) : mapStateToProps; // object or undefined

      return _react2.default.createElement(Component, props);
    }
  }]);

  return ReactiveWrapper;
}(_react2.default.Component);

var addMethods = function addMethods(app, store, element) {
  app.element = function () {
    return element;
  };
  app.story = function () {
    return element;
  };

  app.getState = function () {
    return store.getState();
  };
  app.dispatch = function (action) {
    return store.dispatch(action);
  };

  app.snap = function (action) {
    if (!action) {
      expect(app.tree()).toMatchSnapshot();
    } else {
      var actionShot = typeof action !== 'function' ? action : 'thunk';
      (0, _snap2.default)(actionShot);

      store.dispatch(action);
      (0, _snap2.default)(store.getState());
      app.snap();
    }

    return app;
  };

  app.snapState = function () {
    return (0, _snap2.default)(app.getState());
  };
};